#!/bin/sh
#
# եƻ륹ץ
#
# usage: check_etc.sh

# եΤǥ쥯ȥ
CHECK_ROOT="/etc"

# ƻоݤΥǥ쥯ȥο
MAX_DEPTH=2

# եδǼե
CKSUM_FILE=/usr/local/etc/sumfile

# åޥ
SUM_CMD=sum

# CKSUM_FILE Ѥΰե
cksum_file_tmp="${CKSUM_FILE}.tmp"

# ˱ơ
#   ֥ǥ쥯ȥο + 1
# ɽ glob ѥ
# usage: make_pattern <depth>
# : make_patter 1  "*/*"
make_pattern () {
    i=$1
    pattern="*"

    while [ ${i} -gt 0 ]; do
        pattern="${pattern}/*"
        i=`expr ${i} - 1`
    done

    echo "${pattern}"
}

# ֻꤵ줿ե̾ˤפȤɽ
# 롣
# usage: file2regex <filename>
# : file2regex /etc/nsswitch.conf  "/etc/nsswitch\.conf$"
file2regex() {
    echo "$1" |
        sed -e 's/\./\\./g' \
            -e 's/$/$/'
}

# å/ե°ɽؿ
# usage: calc_sum <filename>
# : calc_sum /etc/passwd
#      12345 -r--r--r-- root 508 Dec 24 19:23 /etc/passwd
calc_sum () {
    sum=`${SUM_CMD} "$1" | cut -d" " -f1`
    
    ls -lc "$1" | (
        read perm link_cnt owner group size month day time fname
        echo "${sum} ${perm} ${owner} ${size} ${month} ${day} ${time} $1"
    )
}

# եƻؿ
# usage: check_sum_files
check_sum_files () {
    pwd=`pwd`
    old_sum=""
    new_sum=""
    file=""
    max_depth=`expr ${MAX_DEPTH} + 1`
    pattern=`make_pattern ${max_depth}`
    regexp=""

    # оݥǥ쥯ȥ˰ư
    cd "${CHECK_ROOT}"

    # եѥʣ
    #   ! \( -name "*.old" -o -name "*.oold" -o ... \)
    # ȵҤ
    find . -mount -type f ! \( -name "*.old" \) -print | \
        while read file; do
	    # 뿼ʾΥեϽ
	    case "${file}" in
                ${pattern})
                    continue
                    ;;
            esac

	    # ե̾ɽ
	    regexp=`file2regex "${file}"`
	    # ¹ԻΥå
	    old_sum=`grep "${regexp}" "${CKSUM_FILE}" 2> /dev/null`
	    if [ $? -ne 0 ]; then
		# ¹ԻΥȥ꤬ʤпե
		echo "NEW FILE: ${file}"
		# ǤΥå׻ƽ񤭹
		calc_sum "${file}" >> "${cksum_file_tmp}"
	    else
		# ǤΥå׻
		new_sum=`calc_sum "${file}"`
		if [ "${old_sum}" != "${new_sum}" ]; then
		    echo "CHANGE FILE: ${file}"
		fi

		# ǤΥå񤭹
		echo "${new_sum}" >> "${cksum_file_tmp}"
	    fi
        done

    # Υǥ쥯ȥ˰ư
    cd "${pwd}"
}

# ե
clean_tmp_file () {
    rm -f "${cksum_file_tmp}" > /dev/null 2>&1
    if [ -f "${cksum_file_tmp}" ]; then
        echo "can't remove temporary file: ${cksum_file_tmp}" 1>&2
        return 1
    fi
}

# åեե֤
update_cksum_file () {
    rm -f "${CKSUM_FILE}" > /dev/null 2>&1
    if [ -f "${CKSUM_FILE}" ]; then
        echo "can't remove old file: ${CKSUM_FILE}" 1>&2
        return 1
    fi

    mv "${cksum_file_tmp}" "${CKSUM_FILE}"
}

# util_common.sh ɤ߹(PATH̤äȤ֤Ƥ)
FILE_UTIL=util_common.sh
. "${FILE_UTIL}"
# LANG Ѹ
unset_linguas

# årootɤ߽񤭲(rw-------)
umask 077

# (Ť)ե
clean_tmp_file || exit 1

# å
check_sum_files

# åե򹹿
update_cksum_file
