#!/bin/bash
#
# ping Ȥä¸ƻ륹ץ
#
# usage: ping.bash

# ƻоݥۥȤ򵭽Ҥե
# (񼰤 1 Ԥ 1 ۥ)
PING_HOSTS="/usr/local/etc/ping_hosts"

# pingޥɥ󥿡ե
# Ȥ:
#   ping_common <hostname> [ <timeout> ]
# :
#   hostname: ۥ̾/IPɥ쥹
#   timeout: pingΥॢ()
# :
#   ʤ(顼ϤϤ)
# λơ:
#   0: 
#   1: ʤ
#   2ʾ: 顼
ping_alive_common () {
    # ƥ(unameη)Ȥ˽ʬ
    case $(uname -s) in
      Linux | NetBSD | OpenBSD)
        ping_alive_bsd $1 $2
        status=$?
        ;;
      SunOS)
	ping_alive_solaris $1 $2
        status=$?
	;;
      FreeBSD)
        ping_alive_freebsd $1 $2
        status=$?
        ;;
      *)
	# 嵭ʳΥƥǤϡʬĴ٤ƽƤ
	echo "This system is not supported." 1>&2
	return 2
	;;
    esac

    return ${status}
}

# Linux/NetBSD/OpenBSDpingޥɥ󥿥ե
# Ȥ:
#   ping_alive_bsd <hostname> [ <timeout> ]
# :
#   hostname: ۥ̾/IPɥ쥹
#   timeout: pingΥॢ()
# :
#   ʤ(顼ϤϤ)
# λơ:
#   0: 
#   1: ʤ(ޤϥ顼)
#   2ʾ: 顼
ping_alive_bsd () {
    local timeout=${2:+"-w $2"}
    local status

    ping -c 1 ${timeout} $1 > /dev/null
    status=$?

    # ʰξϽλơ2ʾ(?)
    if [ $status -ge 2 ]; then
	# timeout ץƺƻ
	ping -c 1 $1 > /dev/null
	status=$?
    fi

    return ${status}
}

# FreeBSDpingޥɥ󥿥ե
# Ȥ:
#   ping_alive_freebsd <hostname> [ <timeout> ]
# :
#   hostname: ۥ̾/IPɥ쥹
#   timeout: pingΥॢ()
# :
#   ʤ(顼ϤϤ)
# λơ:
#   0: 
#   1: ʤ
#   3ʾ: 顼
ping_alive_freebsd () {
    local timeout=${2:+"-t $2"}

    ping -c 1 ${timeout} $1 > /dev/null
    status=$?

    # ʰξ = ŤϽλơ2ʾ
    if [ $? -ge 2 -a "${timeout}" != "" ]; then
	# timeout ץƺƻ
	ping -c 1 $1 > /dev/null
	status=$?
    fi

    case ${status} in
      0)
        return 0
        ;;
      1 | 2)
        return 1
        ;;
      *)
        return ${status}
        ;;
    esac
}

# Solaris(SunOS)pingޥɥ󥿥ե
# Ȥ:
#   ping_alive_solaris <hostname> [ <timeout> ]
# :
#   hostname: ۥ̾/IPɥ쥹
#   timeout: pingΥॢ()
# :
#   ʤ(顼ϤϤ)
# λơ:
#   0: 
#   1: ʤ
#   2ʾ: 顼
ping_alive_solaris () {
    ping $1 $2 > /dev/null
}

# Ʊ ping ¹
# Ȥ:
#   ping_async <hostname> [ <directory> ] [ <timeout> ]
# :
#   hostname: ۥ̾/IPɥ쥹
#   directory: ǥ쥯ȥ(ǥեȤϥȥǥ쥯ȥ)
#   timeout: ping ॢ()
# :
#   ʤ
# λơ:
#   0: pingμ¹Ԥ
#   1ʾ: 顼
ping_async () {
    local hostname=$1
    local resultfile="${2:+${2}/}${hostname}"
    local timeout=$3

    rm -f ${resultfile} > /dev/null 2>&1

    (
        ping_alive_common ${hostname} ${timeout} \
	    > /dev/null 2> "${resultfile}"
	echo $? >> "${resultfile}"
    ) > /dev/null 2>&1 &
}

# Ʊ ping ¹Է̼
# Ȥ:
#   ping_check_result <hostname> [ <directory> ]
# :
#   hostname: ۥ̾/IPɥ쥹
#   directory: ǥ쥯ȥ(ǥեȤϥȥǥ쥯ȥ)
# :
#   ʤ
# λơ:
#   0: 
#   1: ʤ
#   2ʾ: 顼
#   70: (̥ե뤬¸ߤʤ/ɤ߹ʤ)
ping_check_result () {
    local hostname=$1
    local resultfile="${2:+${2}/}${hostname}"
    local num_line
    local status

    [ -r "${resultfile}" ] || return 70
    status=$(tail -1 "${resultfile}")

    # 顼ɽ
    if [ ${status} -ge 2 ]; then
	num_line=$(wc -l "${resultfile}" | awk '{print $1}')
	if [ ${num_line} -gt 1 ]; then
	    sed ${num_line}d "${resultfile}" 1>&2
	fi
    fi

    return ${status}
}

# ʣۥȤؤpingƱ¹
# Ȥ:
#   ping_from_file <filename> [ <directory> ] [ <timeout> ]
# :
#   hostname: ۥ̾/IPɥ쥹
#   directory: ǥ쥯ȥ(ǥեȤϥȥǥ쥯ȥ)
#   timeout: ping ॢ()
# :
#   <ۥ̾>: <ơ>
#   ...
#
#   ơ 0: 1:ʤ 2ʾ:顼
# λơ:
#    0
ping_from_file () {
    local inputfile="$1"
    local hostname
    local dummy

    # ϥեɤ߹ߥå
    if [ ! -r "${inputfile}" ]; then
	echo "No such file/Can't read file: ${inputfile}" 1>&2
	return 1
    fi

    # ֥ѥ᡼ʲΤ褦ˤ
    # $1: result_dir(ά), $2: timeout(ά)
    shift

    # 2ǰʹߤ̵뤹롣ʤ
    #   192.168.1.1 # 롼
    # Τ褦ʵҤ OK Ǥ
    while read hostname dummy; do
	# /ȹԤ̵
	case "${hostname}" in
	  "")   continue ;;
	  "#"*) continue ;;
        esac

	ping_async ${hostname} "$@" > /dev/null
    done < "${inputfile}"

    # ping_async Ǽ¹ԤƱޥɤνλԤ
    wait

    # ֥ѥ᡼ʲΤ褦ˤ
    # $1: result_dir(ά)
    if [ $# -ge 2 ]; then
	set -- "$1"
    fi

    while read hostname dummy; do
	# /ȹԤ̵
	case "${hostname}" in
	  "")   continue ;;
	  "#"*) continue ;;
        esac

	ping_check_result ${hostname} "$@"
	echo "${hostname}: $?"
    done < "${inputfile}"

    return 0
}

# ᥤ

# util_common.bash ɤ߹(make_tmp_dir/clean_tmp_dir)
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ȥǥ쥯ȥκ
tmpdir=$(make_tmp_dir 2>/dev/null)

if [ $? -ne 0 ]; then
    echo "Can't create temporary directory!" 1>&2
    exit 2
fi

# trap 
SIGNALS="HUP INT QUIT PIPE TERM"
trap "{ clean_tmp_dir; exit; }" ${SIGNALS}

# ping ƻμ¹
ping_from_file "${PING_HOSTS}" "${tmpdir}"

# ȥǥ쥯ȥκ trap 
clean_tmp_dir
trap ${SIGNALS}

