#!/bin/bash
#
# ͥեץ

################################################################
# 
################################################################

# HTML
HTML_INDEX="index.html"
HTML_TITLE="TITLE"
HTML_CHARSET="EUC-JP"

# ͥ
THUMB_DIR="thumb"
THUMB_PREFIX="th_"
THUMB_SIZE="120x120"
THUMB_QUALITY=50

################################################################
# 
################################################################

# ϥå
if [ "$1" != "-" ]; then
    if [ ! -r "$1" ]; then
	echo "Can't read file $1"
	exit 1
    fi
fi

# ֤ͥκ
[ -d "${THUMB_DIR}" ] || mkdir "${THUMB_DIR}"
if [ $? -ne 0 ]; then
    exit 1
fi

# HTML Ƭʬ
cat <<EOF > "${HTML_INDEX}"
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
 "http://www.w3.org/TR/html4/strict.dtd">
<html lang="ja">
<head>
  <meta http-equiv="Content-Type"
        content="text/html; charset=${HTML_ChARSET}">
  <title>${HTML_TITLE}</title>
</head>

<body>

<h1>${HTML_TITLE}</h1>
<p>
EOF

# ȤΥ롼
cat "$1" | while read file; do
    thumb="${THUMB_DIR}/${THUMB_PREFIX}${file}"

    convert \
	-size "${THUMB_SIZE}" \
	${THUMB_QUALITY:+-quality ${THUMB_QUALITY}} \
	"${file}" \
	-resize "${THUMB_SIZE}" \
	"${thumb}"

    # Ѵ˼Ԥ̵
    if [ $? -ne 0 ]; then
	continue
    fi

    #HTML
    cat <<-EOF  >> "${HTML_INDEX}"
	    <a href="${file}"><img src="${thumb}"></a>
	EOF

done
# HTML ʬ
cat <<EOF  >> "${HTML_INDEX}"
</p>
</body>
</html>
EOF
