#!/bin/bash
#
# ᡼(ޥѡ)ץ

# ᡼
MAIL_FROM="foo@example.com"
MAIL_TO="bar@example.com"
MAIL_SUBJECT="ե"
SENDMAIL=/usr/lib/sendmail

# ̥ޥ
COMPRESS_CMD="gzip"
COMPRESS_EXT="gz"

# ̤ե
TARGET=/var/log/wtmp

# ޥѡȤζ򼨤ʸ
BOUNDARY="--BOUNDARY__$(date +%Y%m%d%H%M%S)__$$__--"

# ᡼إåκ
# 
#   $1: Header From
#   $2: Header To
#   $3: Subject
#   $4: Boundary
make_mail_header () {
    # ߻
    local message_date=$(date +"%a, %e %b %Y %H:%M:%S %z")
    # դ򸵤 Message-Id 
    local message_id="<$(date +%Y%m%d%H%M%S).$(id -ru).$$@$(hostname)>"
    # ֥Ȥ Base64 󥳡ǥ
    local subject=$(
	echo -n "$3" | \
        iconv -f EUC-JP -t ISO-2022-JP | \
        perl -MMIME::Base64 -ne 'print encode_base64($_)')
    # 
    local boundary="$4"

    # إå
cat <<EOF
Mime-Version: 1.0
Content-Type: Multipart/Mixed;
 boundary="${boundary}"
Content-Transfer-Encoding: 7bit
From: $1
To:   $2
Subject: =?ISO-2022-JP?B?${subject}?=
Message-Id: ${message_id}
Date: ${message_date}

EOF
}

# ᡼ܥǥƬκ
# 
#   $1: Boundary
make_mail_body_top () {
    cat <<EOF
This is a MIME-encapsulated message.

--$1
Content-Type: Text/Plain; charset=iso-2022-jp
Content-Transfer-Encoding: 7bit

EOF
}
    
# ᡼ܥǥκ
# 
#   $1: Boundary
make_mail_body_bottom () {
    echo
    echo "--${1}--"
}

# źեեκ
# 
#   $1: Boundary
#   $2: Filename
#   $3: Content-Type(ά "Хʥ")
make_mail_body_attachment () {
    local boundary="$1"
    local filename="$2"
    local content_t="${3:-Application/Octet-Stream}"

    cat <<EOF

--${boundary}
Content-Type: ${content_t}
Content-Transfer-Encoding: base64
Content-Disposition: attachment;
 filename$(encode_rfc2231 "${filename}")

EOF

    perl <<-EOF
	use MIME::Base64 qw(encode_base64);

	open(FILE, "${filename}") or die "\$\!";
	while (read(FILE, \$buf, 60*57)) {
	    print encode_base64(\$buf);
	}
EOF
}

# źեեΥե̾򥨥󥳡ɤ
# (ե̾򤽤Τޤ޽Ϥ "=ե̾"
#  沽ˤ "*=沽줿ʸ")
# 
#   $1: ե̾
encode_rfc2231 () {
    local basename=${1##*/}
    local encoded
    echo "${basename}" | grep -q '^[0-9a-zA-Z]*$'

    # üʸޤޤƤʤ
    if [ $? -eq 0 ]; then
	echo "=${basename}"
	return
    fi

    # üʸޤޤƤ
    #  ISO-2022-JP ˤƤ饨󥳡
    encoded=$(
	echo -n ${basename} | \
	iconv -f EUC-JP -t ISO-2022-JP | \
        perl -p -e 's/([^[:alnum:]])/"%" . unpack("H2", $1)/eg' )

    echo -n "*=iso-2022-jp'ja'${encoded}" 
}

# ꤵ줿ե᡼Ȥ
# 
#   $1: ᡼ե
# оݤ EUC ܸ᡼Ȳꤷơ
#   ISO-2022-JPѴ
# إå˽񤫤줿 To:, Cc:, Bcc: ˥᡼
send_mail () {
    iconv -f EUC-JP -t ISO-2022-JP "${mail_data}" | \
	"${SENDMAIL}" -oi -t > /dev/null 2>&1
}

# ̴ؿɤ߹
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ʸɤѸ
unset_linguas

# ȥǥ쥯ȥκ
tmpdir=$(make_tmp_dir 2>/dev/null)
if [ $? -ne 0 ]; then
    echo "Can't create temporary directory!" 1>&2
    exit 2
fi

# trap 
SIGNALS="HUP INT QUIT PIPE TERM"
trap "{ clean_tmp_dir; exit; }" ${SIGNALS}

# ${TARGET} ե򰵽̤
compressed="${TARGET##*/}.${COMPRESS_EXT}"
cat "${TARGET}" | "${COMPRESS_CMD}" > "${tmpdir}/${compressed}"

# ᡼ե
mail_data=${tmpdir}/mail_data

# إå
make_mail_header "${MAIL_FROM}" "${MAIL_TO}" \
                 "${MAIL_SUBJECT}" "${BOUNDARY}" \
    > "${mail_data}"

# ܥǥ
make_mail_body_top "${BOUNDARY}" \
    >> "${mail_data}"

cat <<EOF >> "${mail_data}"
 ${0##*/} ץȤˤ꼫ưŪƤޤ

EOF

# ̤եź
make_mail_body_attachment "${BOUNDARY}" "${tmpdir}/${compressed}" \
    >> "${mail_data}"

make_mail_body_bottom "${BOUNDARY}" \
    >> "${mail_data}"

# ᡼
send_mail "${mail_data}"

# ȥǥ쥯ȥκ trap 
clean_tmp_dir
trap ${SIGNALS}
