#!/bin/bash
#
# ᡼(uuencode)ץ

# ᡼
MAIL_FROM="foo@example.com"
MAIL_TO="bar@example.com"
MAIL_SUBJECT="ե"
SENDMAIL=/usr/lib/sendmail

# ̥ޥ
COMPRESS_CMD="gzip"
COMPRESS_EXT="gz"

# /uuencode ե
TARGET=/var/log/syslog

# ᡼إåκ
# 
#   $1: Header From
#   $2: Header To
#   $3: Subject
make_mail_header () {
    # ߻
    local message_date=$(date +"%a, %e %b %Y %H:%M:%S %z")
    # դ򸵤 Message-Id 
    local message_id="<$(date +%Y%m%d%H%M%S).$(id -ru).$$@$(hostname)>"
    # ֥Ȥ Base64 󥳡ǥ
    local subject=$(
	echo -n "$3" | \
        iconv -f EUC-JP -t ISO-2022-JP | \
        perl -MMIME::Base64 -ne 'print encode_base64($_)')

    # إå
cat <<EOF
Mime-Version: 1.0
Content-Type: Text/Plain; charset=iso-2022-jp
Content-Transfer-Encoding: 7bit
From: $1
To:   $2
Subject: =?ISO-2022-JP?B?${subject}?=
Message-Id: ${message_id}
Date: ${message_date}

EOF
}

# ꤵ줿ե᡼Ȥ
# 
#   $1: ᡼ե
# оݤ EUC ܸ᡼Ȳꤷơ
#   ISO-2022-JPѴ
# إå˽񤫤줿 To:, Cc:, Bcc: ˥᡼
send_mail () {
    iconv -f EUC-JP -t ISO-2022-JP "${mail_data}" | \
	"${SENDMAIL}" -oi -t > /dev/null 2>&1
}

# ̴ؿɤ߹
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ʸɤѸ
unset_linguas

# ȥǥ쥯ȥκ
tmpdir=$(make_tmp_dir 2>/dev/null)
if [ $? -ne 0 ]; then
    echo "Can't create temporary directory!" 1>&2
    exit 2
fi

# trap 
SIGNALS="HUP INT QUIT PIPE TERM"
trap "{ clean_tmp_dir; exit; }" ${SIGNALS}

# ᡼ե
mail_data=${tmpdir}/mail_data

make_mail_header "${MAIL_FROM}" "${MAIL_TO}" "${MAIL_SUBJECT}" \
    > "${mail_data}"

cat <<EOF >> "${mail_data}"
 ${0##*/} ץȤˤ꼫ưŪƤޤ

EOF

# ${TARGET} ե򰵽̤
compressed="${TARGET##*/}.${COMPRESS_EXT}"
cat "${TARGET}" | "${COMPRESS_CMD}" > "${tmpdir}/${compressed}"
# ̤ե UUencode
uuencode "${tmpdir}/${compressed}" "${compressed}" >> "${mail_data}"

send_mail "${mail_data}"

# ȥǥ쥯ȥκ trap 
clean_tmp_dir
trap ${SIGNALS}
