#!/bin/bash
#
# MySQL(mod_auth_mysql) Ȥä BASIC ǧڤΤΥġ
# -- ơ֥ SQLhttpd Ѥեޤ

################################################################
# 
################################################################

#### 
# 
OUTPUT_SQL=create_auth.sql
OUTPUT_CONF=auth_mysql.conf
# ǧڥȥ
AUTH_NAME="Authentication"

#### ǥե
# DB ̾/ȥ桼(DBΥ桼)/ѥ
DB_NAME="auth"
DB_USER="authuser"
DB_PASS=""
# ơ֥̾(桼/롼)
TBL_USER="users"
TBL_GROUP="groups"
# ̾(桼/롼/ѥ)
COL_USER="user_name"
COL_GROUP="group_name"
COL_PASS="passwd"
# оݥǥ쥯ȥ
DOC_ROOT="/var/www/html"

################################################################
# ؿ
################################################################
# ѥɤϤؿ
# :
#   $1: ѥɤκʸ(άǥե8)
# : ѥʸ
query_passwd () {
    local pass_len="$1"
    local passwd_1
    local passwd_2

    # ѥɤκʸη
    [ "${pass_len}" -gt 0 ] 2> /dev/null
    if [ $? -ne 0 ]; then
	pass_len=8
    fi

    # 2ϤΤפޤǥ롼פ
    while :; do
	stty -echo
	echo -n "Password: " 1>&2
	read -r passwd_1
	stty echo
	echo 1>&2

	stty -echo
	echo -n "Re-Enter Password: " 1>&2
	read -r passwd_2
	stty echo
	echo 1>&2

	# ѥɤפХ롼פȴ
	if [ "${passwd_1:0:${pass_len}}" \
             == "${passwd_2:0:${pass_len}}" ]; then
	    break
	fi

	echo "Those two passwords don't match." 1>&2
	echo "Try again!" 1>&2
	echo 1>&2
    done

    echo "${passwd_1:0:${pass_len}}"
}

# SQL ʸ󥨥׽ؿ
#   \  \\
#   '  \'
# 
#   $1: оʸ
# 
#   ׽줿ʸ
# :
#   ѥʸꤷƤʤ
escape_sql_str () {
    cat <<-EOF | sed 's/\([\\'"'"']\)/\\\1/g'
	$1
	EOF
}

# ʸ󥨥׽ؿ
#   " $ ` \ γʸ \ ǥפ
# 
#   $1: оʸ
# 
#   פ줿ʸ
escape_shell_str () {
    echo "$1" | sed 's/\(["$`\\]\)/\\\1/g'
}

# Apacheեʸ󥨥׽ؿ
#   " \ γʸ \ ǥפ
# 
#   $1: оʸ
# 
#   פ줿ʸ
escape_apconf_str () {
    echo "$1" | sed 's/\(["\\]\)/\\\1/g'
}

# SQL ʸؿ
# 
#   $1: DB̾
#   $2: DBȥ桼
#   $3: 嵭桼Υѥ
#   $4: 桼Ǽơ֥̾
#   $5: 롼׳Ǽơ֥̾
#   $6: ̾: "桼̾"
#   $7: ̾: "롼̾"
#   $8: ̾: "ѥ"
# 
#   SQLʸ
create_sql () {
    local db_name="$1"
    local db_user="$2"
    local db_pass="$3"
    local tbl_user="$4"
    local tbl_group="$5"
    local col_user="$6"
    local col_group="$7"
    local col_pass="$8"

    cat <<-EOF
	CREATE DATABASE ${db_name};
	USE ${db_name};
	CREATE TABLE ${tbl_user} (
	    ${col_user} CHAR(30) NOT NULL,
	    ${col_pass} CHAR(20) NOT NULL,
	    PRIMARY KEY (${col_user})
	);
	CREATE TABLE ${tbl_group} (
	    ${col_user} CHAR(30) NOT NULL,
	    ${col_group} CHAR(20) NOT NULL,
	    PRIMARY KEY (${col_user}, ${col_group})
	);
	GRANT SELECT
	    ON ${db_name}.${tbl_user}
	    TO ${db_user}@localhost
            IDENTIFIED BY '$(escape_sql_str "${db_pass}")';
	GRANT SELECT
	    ON ${db_name}.${tbl_group}
	    TO ${db_user}@localhost;
	EOF
}

# apache եؿ
# :
#   $1: ǧڤоݤΥǥ쥯ȥ
#   $2: ǧڤΥȥ
#   $3: DB̾
#   $4: DBȥ桼
#   $5: 嵭桼Υѥ
#   $6: 桼Ǽơ֥̾
#   $7: 롼׳Ǽơ֥̾
#   $8: ̾: "桼̾"
#   $9: ̾: "롼̾"
#   $10: ̾: "ѥ"
create_conf () {
    local dir="$1"
    local auth_name="$2"
    shift 2
    local db_name="$1"
    local db_user="$2"
    local db_pass="$3"
    local tbl_user="$4"
    local tbl_group="$5"
    local col_user="$6"
    local col_group="$7"
    local col_pass="$8"

    cat <<EOF
# Load module
LoadModule mysql_auth_module modules/mod_auth_mysql.so

<Directory ${dir}>
    AuthName "${auth_name}"
    AuthType Basic

    AuthMySQLUser          ${db_user}
    AuthMySQLPassword      "$(escape_apconf_str "${db_pass}")"
    AuthMySQLDB            ${db_name}
    AuthMySQLUserTable     ${tbl_user}
    AuthMySQLNameField     ${col_user}
    AuthMySQLPasswordField ${col_pass}
    AuthMySQLGroupTable    ${tbl_group}
    AuthMySQLGroupField    ${col_group}

    require valid-user
</Directory>
EOF
}

# 桼ؤ碌ؿ
# 
#   $1: ꤹѿ̾ǥեͤȤƻȤ⤹
#   $2: 碌ʸ
#   $3: readޥɤϥץץ(ά)
# 
#   ʤ($1 ǻꤵ줿̾ѿͤåȤ)
query_user () {
    local var="$1"
    local value
    local q="$2"
    local prompt="$3"
    local line

    if [ "${prompt}" = "" ]; then
	eval prompt="\"(default: '\$${var}')> \""
    fi

    clear 1>&2
    echo "${q}" 1>&2
    read -p "${prompt}" line

    # ꥿ΤߤξϡǥեȤΤޤ
    if [ "${line}" == "" ]; then
	return
    fi

    # ɤ߹ͤ $var Ǽѿ˥åȤ
    value=$(escape_shell_str "${line}")
    eval "${var}=\"${value}\""
}

################################################################
# ᥤ
################################################################

# եˤϥѥɤΤޤ޽񤫤Τ
umask 077

# 桼ؤ碌
query_user DB_NAME "Input DB space name"
query_user DB_USER "Input DB user for 'SELECT'"
query_user TBL_USER  "Input table name for users"
query_user TBL_GROUP "Input table name for groups"
query_user COL_USER  "Input column name for user"
query_user COL_GROUP "Input column name for group"
query_user COL_PASS  "Input column name for password"
query_user DOC_ROOT "Input Document-root for authentication"

# ѥɤ碌Τ̴ؿ
clear 1>&2
echo "Input ${DB_USER}'s pass on mysql" 1>&2
DB_PASS=$(query_passwd)

# SQL ʸ
create_sql \
    "${DB_NAME}" \
    "${DB_USER}" \
    "${DB_PASS}" \
    "${TBL_USER}" \
    "${TBL_GROUP}" \
    "${COL_USER}" \
    "${COL_GROUP}" \
    "${COL_PASS}" > "${OUTPUT_SQL}"

# ե
create_conf \
    "${DOC_ROOT}" \
    "${AUTH_NAME}" \
    "${DB_NAME}" \
    "${DB_USER}" \
    "${DB_PASS}" \
    "${TBL_USER}" \
    "${TBL_GROUP}" \
    "${COL_USER}" \
    "${COL_GROUP}" \
    "${COL_PASS}" > "${OUTPUT_CONF}"
    
