#!/bin/bash
#
# configure ݡȥץ

# m4 եΤ
CONFIG_LIB="/usr/local/lib/configure_wrap/"
# 
OUTPUT="configure.args"

########################################################
# Ķå
########################################################
# ǥ쥯ȥå
if [ ! -d "${CONFIG_LIB}" ]; then
    echo "Can't find LIB directory."
    exit 1
fi

# ޥե¸ߥå
# configure.in ¸ߥå
for file in \
    "${CONFIG_LIB}/pick_arg_enable.m4" \
    "${CONFIG_LIB}/my_arg_enable.m4" \
    ./configure.in
do
    if [ ! -f "${file}" ]; then
	echo "No such file: ${file}"
	exit 1
    fi
done

########################################################
# 
########################################################
# ѹ
if [ "$1" != "" ]; then
    OUTPUT="$1"
fi

########################################################
# ȥǥ쥯ȥκ
########################################################
# util_common.bash ɤ߹(make_tmp_dir/clean_tmp_dir)
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ȥǥ쥯ȥκ
tmpdir=$(make_tmp_dir 2>/dev/null)
if [ $? -ne 0 ]; then
    echo "Can't create temporary directory!" 1>&2
    exit 2
fi

# trap 
SIGNALS="HUP INT QUIT PIPE TERM"
trap "{ clean_tmp_dir; exit; }" ${SIGNALS}

########################################################
# ᥤ
########################################################

preprocessed="${tmpdir}/wrapped"
m4 "${CONFIG_LIB}/pick_arg_enable.m4" ./configure.in \
    > "${preprocessed}"

umask 077

cat <<-EOF | m4 > "${tmpdir}/configure"
	#!/bin/bash
	include(${CONFIG_LIB}/my_arg_enable.m4)
	divert(-1)
	include(${preprocessed})
EOF

chmod 700 "${tmpdir}/configure"

"${tmpdir}/configure" > "${OUTPUT}"

########################################################
# 
########################################################
# ȥǥ쥯ȥκ trap 
clean_tmp_dir
trap ${SIGNALS}
