#!/bin/bash
#
# CSV ե뤫 CREATE TABLE ʸġ

TBL_NAME="$1"
INPUT_CSV="$2"

################################################################
# ؿ
################################################################
# 顼Ϥ򤷡λơ1ǥλ
# 
#   $1: ̾
format_error() {
    # å
    echo "Column specification error: $1" 1>&2
    # ݽ
    clean_tmp_dir
    trap ${SIGNALS}
    # λ
    exit 1
}

# 1 Ԥؿ
# 
#   $1: о
# 
#   ɸ: CREATE TABLE ʸΰ
#   եǥץ3:
#     ץ饤ޥ꡼Υ̾
proc_line () {
    echo "$1" \
    | tr -d '\015' \
    | perl -n -e '
	chomp();
        $_ .= ",";
	@csv = /([^,"]*|"(?:""|[^"])*"),/g;
	print $csv[0], "\n";
	print $csv[1], "\n";
	print $csv[2], "\n";
	print $csv[3], "\n";' \
    | (
	read csv_1
	read csv_2
	read csv_3
	read csv_4
	proc_line_sub "${csv_1}" "${csv_2}" "${csv_3}" "${csv_4}"
      )
}

# CSV Ǥˤ֥륯Ȥ
# 
#   $1: оʸ
dequote_csv () {
    echo "$1" | sed -e 's/^"//' -e 's/"$//' -e 's/""/"/g'
}

# Ϥ줿󤫤顢CREATE TABLE 1 ʬ
# 
#   $1: ץ饤ޥ꡼Ǥв餫ʸ
#   $2: ̾
#   $3: 
#   $4: "NOT NULL" ޤ϶ʸ
# 
#   ɸ: CREATE TABLE ʸΰ
#   եǥץ3:
#     ץ饤ޥ꡼Υ̾
proc_line_sub () {
    local is_pk=$(dequote_csv "$1")
    local col_name=$(dequote_csv "$2")
    local col_type=$(dequote_csv "$3")
    local not_null=$(dequote_csv "$4")
    local unsigned
    local type_sub

    # Primary Key
    if [ "${is_pk}" != "" ]; then
	echo "${col_name}" 1>&3
    fi

    # ̾ʸ
    col_type=$(echo "${col_type}" | tr 'a-z' 'A-Z')

    #  UNSIGNED դƤ뤫Υå
    echo "${col_type}" | grep -q 'UNSIGNED$'
    if [ $? -eq 0 ]; then
	unsigned="UNSIGNED"
	col_type=$(echo "${col_type}" | sed 's/ *UNSIGNED//')
    else
	unsigned=""
    fi

    # λΥå
    type_sub=$(echo "${col_type}" | sed -n 's/.*\((.*)\)/\1/p')
    if [ "${type_sub}" != "" ]; then
	col_type=$(echo "${col_type}" | sed -e 's/(.*//')
    fi

    # not null Υå
    not_null=$(echo "${not_null}" | tr 'a-z' 'A-Z')
    case "${not_null}" in
	"NOT NULL"| "")
	    # ̵
	    ;;
	*)
	    # 顼
	    format_error "${col_name}"
	    ;;
    esac

    case "${col_type}" in
	  TINYINT   | SMALLINT \
	| MEDIUMINT | INT      \
	| INTEGER   | BIGINT )
	# UNSIGNEDַפλ꤬
	echo "${type_sub}" | grep -q ","
	if [ $? -eq 0 ]; then
	    format_error "${col_name}"
	fi
	;;

	  REAL    | DOUBLE  \
	| FLOAT   | DECIMAL \
	| NUMERIC )
	#  UNSIGNED/type_sub/decimalλ꤬
	;;

	CHAR | VARCHAR)
	# type_sub ǷɬܡUNSIGNEDԲ
	if [ "${type_sub}" == "" ]; then
	    format_error "${col_name}"
	fi

	echo "${type_sub}" | grep -q ","
	if [ $? -eq 0 ]; then
	    format_error "${col_name}"
	fi
	;;

	  TINYBLOB   | TINYTEXT   \
	| BLOB       | TEXT       \
	| MEDIUMBLOB | MEDIUMTEXT \
	| LONGBLOB   | LONGTEXT   \
	| DATE       | TIME       \
	| TIMESTAMP  | DATETIME )
	# type_sub ԲġUNSIGNEDԲ
	if [ "${type_sub}${unsigned}" != "" ]; then
	    format_error "${col_name}"
	fi
	;;

	ENUM | SET)
	# type_sub ɬܡUNSIGNEDԲ
	if [ "${type_sub}" == "" \
	     -o "${unsigned}" != "" ]; then
	    format_error "${col_name}"
	fi
	;;

	*)
	# 곰η
	format_error "${col_name}"
	;;
    esac

    printf '    %s %s%s %s %s,\n' \
	"${col_name}" "${col_type}" "${type_sub}" \
	"${unsigned}" "${not_null}"
}

# Primary Key ʸؿ
# 
#   $1: ץ饤ޥ꡼Υ̾񤫤줿ե
# 
#   ", PRIMARY KEY ( ... )"
proc_pk () {
    local columns

    # ƹԤ "," Ƕڤä 1 Ԥ
    columns=$(
	cat "$1" | while read column; do
	    echo -n "${column}, "
	done
    )

    if [ "${columns}" != "" ]; then
	echo "    , PRIMARY KEY ( ${columns%,*} )"
    fi
}

########################################################
# ȥǥ쥯ȥκ
########################################################
# util_common.bash ɤ߹(make_tmp_dir/clean_tmp_dir)
FILE_UTIL=util_common.bash
. "${FILE_UTIL}" 2> /dev/null \
    || . "${0%/*}/${FILE_UTIL}" 2> /dev/null
if [ $? -ne 0 ]; then
    echo "Can't load ${FILE_UTIL}!" 1>&2
    exit 1
fi

# ȥǥ쥯ȥκ
tmpdir=$(make_tmp_dir 2>/dev/null)
if [ $? -ne 0 ]; then
    echo "Can't create temporary directory!" 1>&2
    exit 2
fi

# trap 
SIGNALS="HUP INT QUIT PIPE TERM"
trap "{ clean_tmp_dir; exit; }" ${SIGNALS}

########################################################
# ᥤ
########################################################
# Ǽե
columns="${tmpdir}/columns"
# ץ饤ޥ꡼ξǼե
primary_k="${tmpdir}/pk"

cat "${INPUT_CSV}" | while read line; do
    proc_line "${line}"
done  1> "${columns}" 3> "${primary_k}"

# ̤
echo "CREATE TABLE ${TBL_NAME} ("
cat "${columns}" | sed '$ s/,[^,]*$//'
proc_pk "${primary_k}"
echo ");"

########################################################
# 
########################################################
# ȥǥ쥯ȥκ trap 
clean_tmp_dir
trap ${SIGNALS}
